<?php

// Generate full path of a file.
// Absoulate Path.

function atfc_get_file_full_path($url)
{
    // echo "<pre>";
    // print_r($url);
    // echo "</pre>";
    // Modify URL.

    $old_url = $url;

    if (strpos($old_url, 'http') !== 0) {
        $url = get_home_url() . '/' . ltrim($old_url, '/');;
    }

    return $url;
}

function atfc_remote_file_size($url)
{

    $fileSize = 0; //default.
    $fileFullPath = atfc_get_file_full_path($url);

    // echo "<pre>";
    // print_r($url);
    // echo "</pre>";
    // Invalid URL http://demos.coolajax.net/comingsoon/blue_theme.zip
    # Get all header information

    // echo "<pre>";
    // print_r(filter_var($fileFullPath, FILTER_VALIDATE_URL));
    // echo "</pre>";

    if (filter_var($fileFullPath, FILTER_VALIDATE_URL)) { // check if the file path is valid.

        $fileMetaData = @get_headers($fileFullPath, true);

        // echo "<pre>";
        // print_r($fileMetaData);
        // echo "</pre>";

        // Fixed In version 1.0.8

        if ($fileMetaData !== false) {

            if (isset($fileMetaData['content-length'])) {
                $fileSize = $fileMetaData['content-length'];
            } else if (isset($fileMetaData['Content-Length'])) {
                $fileSize = $fileMetaData['Content-Length'];
            } else {
                $fileSize = 0;
            }
        }
    }

    return (int) $fileSize; // Return always integer value.
}

if (!is_admin()) {

    if (isset($_GET['id']) && is_numeric($_GET['id']) && isset($_GET['atfc']) && is_numeric($_GET['atfc'])) {

        // We keep the track by product id.
        // Total count: atfc_download_count = total count.
        // Product Wise Count: product_id'_'.attachment_id.'_'.atfc_dload
        // Update Total Count.
        $atfc_dload = get_post_meta($_GET['id'], 'atfc_dload', true);
        update_post_meta($_GET['id'], 'atfc_dload', (int) $atfc_dload + 1);


        // Update Product Wise Total Count.
        $product_wise_meta_key = $_GET['id'] . '_' . $_GET['atfc'] . '_atfc_dload';
        $total_atfc_dload = get_post_meta($_GET['id'], $product_wise_meta_key, true);
        update_post_meta($_GET['id'], $product_wise_meta_key, (int) $total_atfc_dload + 1);

        // Update custom table data too.
        // custom table schema
        // id, product_id, atfc_id, ip, date_time
        // Insert  Data

        global $wpdb;

        $atfc_data_table = $wpdb->prefix . "atfc_data"; // for deatils. each day info.

        $wpdb->insert(
            $atfc_data_table,
            array(
                'postid' => $_GET['id'],
                'atfc_id' => $_GET['atfc'],
                'atfc_dload' => 1,
                'ip_dload' => $_SERVER['REMOTE_ADDR'],
                'dload_date' => date("Y-m-d H:i:s")
            ),
            array('%d', '%d', '%d', '%s', '%s')
        );


        // Call the full URL to the file
        $file = atfc_get_file_full_path(wp_get_attachment_url($_GET['atfc']));

        // Get just the file name
        $file_name = basename($file);

        if (isset($file)) {
            //Getting the path to work with filesize()
            $wp_upload_dir = wp_upload_dir();
            $current_upload_dir = $wp_upload_dir['path'];
            $filepath = $current_upload_dir . '/' . $file_name;

            // Checking MIME type and setting accordingly
            switch (strtolower(substr(strrchr($file_name, '.'), 1))) {
                case 'pdf':
                    $mime = 'application/pdf';
                    break;
                case 'zip':
                    $mime = 'application/zip';
                    break;
                case 'jpeg':
                    $mime = 'image/jpg';
                    break;
                case 'jpg':
                    $mime = 'image/jpg';
                    break;
                case 'png':
                    $mime = 'image/jpg';
                    break;
                default:
                    $mime = 'application/force-download';
            }
            // Send headers
            header('Pragma: public');   // required
            header('Expires: 0');    // no cache
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Cache-Control: private', false);
            header('Content-Type: ' . $mime);
            header('Content-Disposition: attachment; filename="' . basename($file_name) . '"');
            header('Content-Transfer-Encoding: binary');
            //header('Content-Length: '.filesize($filepath));  // provide file size
            header('Connection: close');
            readfile($file);    // push it out
            exit();
        }
    }
}